require 'spec_helper'

describe Buyatabwrapper do
  describe '.purchase_card' do
    let(:params) {{ card_number: 123 }}

    it 'calls selfs send_request' do
      expect(Buyatabwrapper).to receive(:send_request).with(:purchase_card, card_number: 123)
      Buyatabwrapper.purchase_card(params)
    end
  end

  describe '.get_merchants' do
    it 'calls selfs send_request' do
      expect(Buyatabwrapper).to receive(:send_request).with(:get_merchants)
      Buyatabwrapper.get_merchants
    end
  end

  describe '.send_request' do
    let(:params) {{ card_number: 123 }}
    let(:api) { double('api') }

    before { allow(Buyatabwrapper::API).to receive(:new).and_return(api) }

    it 'calls apis send_request' do
      expect(api).to receive(:send_request).with(:purchase_card, card_number: 123)
      Buyatabwrapper.send_request(:purchase_card, params)
    end
  end
end
